#module load valgrind/3.10
#module load zlib/1.2.8
gcc ./sources/*.c -lgsl -lgslcblas -lm -o ./bin/mstatspop -Wall -DinGSL=1 -O3 -lz -g
gcc -o ./bin/ms ./sources_msHudson/ms.c ./sources_msHudson/streec.c ./sources_msHudson/rand2.c -lm -O3

cd ./Examples

valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -h > ../mstatspop_help.txt 2> valgrind00.txt

#valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f tfa -i ../test.iSNPcall.replicate2.Ind1.pileup_p02.gz -T ../test.iSNPcall.replicate2.Ind1.pileup_p02_results.txt -o 0 -N 1 2 -n chr1 -G 0 -u 1 -w 100000 2> ../valgrind00b.txt
#exit;
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f fasta -i ./100Kchr10.fa -o 0 -N 1 42   -T ./mstatspop_100chr10.fa.01.txt -K 1 -n chr10 2> valgrind01.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f fasta -i ./100Kchr10.fa -o 1 -N 1 42   -T ./mstatspop_100chr10.fa.01b.txt -K 1 -n chr10 2> valgrind02.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f fasta -i ./100Kchr10.fa -o 0 -N 2 40 2 -T ./mstatspop_100chr10.fa.02.txt -K 1 -n chr10 2> valgrind03.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f fasta -i ./100Kchr10.fa -o 0 -N 2 40 2 -T ./mstatspop_100chr10.fa.03.txt -G 1 -K 1 -n chr10 2> valgrind04.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f fasta -i ./100Kchr10.fa -o 0 -N 2 40 2 -T ./mstatspop_100chr10.fa.04.txt -G 1 -u 1 -K 1 -n chr10 2> valgrind05.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f fasta -i ./100Kchr10.fa -o 0 -N 3 20 20 2 -T ./mstatspop_100chr10.fa.05.txt -G 1 -u 1 -K 1 -n chr10 2> valgrind06.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f fasta -i ./100Kchr10.fa -o 0 -N 2 40 2 -T ./mstatspop_100chr10.fa.06.txt -G 1 -u 1 -p 2 -K 1 -n chr10 2> valgrind07.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f fasta -i ./100Kchr10.fa -o 0 -N 2 40 2 -T ./mstatspop_100chr10.fa.07.txt -G 1 -u 1 -g ./100Kchr10.gtf nonsynonymous Nuclear_Universal -c max -K 1 -n chr10 2> valgrind08.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f fasta -i ./100Kchr10.fa -o 0 -N 3 20 20 2 -T ./mstatspop_100chr10.fa.08.txt -G 1 -u 1 -t 1000 -s 1684 -K 1 -n chr10 2> valgrind09.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f fasta -i ./100Kchr10.fa -o 0 -N 3 20 20 2 -T ./mstatspop_100chr10.fa.09.txt -G 1 -u 1 -K 1 -O 42 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 40 41 -n chr10 2> valgrind10.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f fasta -i ./100Kchr10.fa -o 0 -N 3 20 20 2 -T ./mstatspop_100chr10.fa.10.txt -G 1 -u 1  -g ./100Kchr10.gtf nonsynonymous Nuclear_Universal -c max -K 1 -n chr10 2> valgrind11.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f fasta -i ./100Kchr10.fa -o 0 -N 3 20 20 2 -T ./mstatspop_100chr10.fa.11.txt -G 1 -u 1 -K 0 -O 42 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 40 41  -g ./100Kchr10.gtf nonsynonymous Nuclear_Universal -c max -n chr10 2> valgrind12.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_tfa2ms_02.ms.txt -o 0 -N 1 42 -T ./mstatspop_100chr10.ms.00.txt -l 100000 -n chr10 2> valgrind13.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_tfa2ms_02.ms.txt -o 0 -N 1 42 -T ./mstatspop_100chr10.ms.01.txt -l 100000 -m ./100Kchr10_fa2ms_02.ms.txt_npops1_nsam42_ExcludeMissingVariantsmhits_NOoutg_ploidy1_MASK.txt -n chr10 2> valgrind14.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_tfa2ms_02.ms.txt -o 1 -N 1 42 -T ./mstatspop_100chr10.ms.01b.txt -l 100000 -m ./100Kchr10_fa2ms_02.ms.txt_npops1_nsam42_ExcludeMissingVariantsmhits_NOoutg_ploidy1_MASK.txt -n chr10 2> valgrind15.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_tfa2ms_03.ms.txt -o 0 -N 2 40 2 -T ./mstatspop_100chr10.ms.02.txt -l 100000 -m ./100Kchr10_fa2ms_07.ms.txt_npops2_nsam42_ExcludeMissingVariantsmhits_NOoutg_ploidy1_MASK.txt -n chr10 2> valgrind16.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_tfa2ms_03.ms.txt -o 0 -N 2 40 2 -T ./mstatspop_100chr10.ms.03.txt -l 100000 -G 1 -m ./100Kchr10_fa2ms_07.ms.txt_npops2_nsam42_ExcludeMissingVariantsmhits_NOoutg_ploidy1_MASK.txt -n chr10 2> valgrind17.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_tfa2ms_07.ms.txt -o 1 -N 1 42 -T ./mstatspop_100chr10.ms.04.txt -l 10000 -r 5 -n chr10 2> valgrind18.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_tfa2ms_06.ms.txt -o 1 -N 2 40 2 -T ./mstatspop_100chr10.ms.05.txt -l 10000 -r 5 -n chr10 2> valgrind19.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_tfa2ms_06.ms.txt -o 1 -N 2 40 2 -T ./mstatspop_100chr10.ms.06.txt -l 10000 -r 5 -F 1 -n chr10 2> valgrind20.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_tfa2ms_06.ms.txt -o 1 -N 2 40 2 -T ./mstatspop_100chr10.ms.07.txt -l 10000 -r 5 -F 1 -q 0.01 -n chr10 2> valgrind21.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_tfa2ms_06.ms.txt -o 1 -N 2 40 2 -T ./mstatspop_100chr10.ms.08.txt -l 10000 -r 5 -G 1 -v 2.0 -n chr10 2> valgrind22.txt
../bin/ms 42 1 -t 1000 -I 2 40 2 -ej 2.0 2 1 -p 9 > ./100Kchr10_simulation.ms.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_simulation.ms.txt -o 0 -N 2 40 2 -T ./mstatspop_100chr10.ms.09.txt -l 100000 -G 1 -u 1 -m ./100Kchr10_fa2ms_07.ms.txt_npops2_nsam42_ExcludeMissingVariantsmhits_NOoutg_ploidy1_MASK.txt -n chr10 2> valgrind24.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_simulation.ms.txt -o 0 -N 2 40 2 -T ./mstatspop_100chr10.ms.10.txt -l 100000 -G 1 -u 1 -m ./100Kchr10_fa2ms_04.ms.txt_npops1_nsam42_nonsynonymous_max_ExcludeMissingVariantsmhits_NOoutg_ploidy1_MASK.txt -n chr10 2> valgrind25.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_simulation.ms.txt -o 0 -N 2 40 2 -T ./mstatspop_100chr10.ms.11.txt -l 100000 -G 1 -u 1 -m ./100Kchr10_fa2ms_04.ms.txt_npops1_nsam42_nonsynonymous_max_ExcludeMissingVariantsmhits_NOoutg_ploidy1_MASK.txt -t 1000 -s 1684 -n chr10 2> valgrind26.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_simulation.ms.txt -o 0 -N 2 40 2 -G 1 -T ./mstatspop_100chr10.ms.12.txt -l 100000 -G 1 -u 1 -m ./100Kchr10_fa2ms_04b.ms.txt_npops2_nsam42_nonsynonymous_max_ExcludeMissingVariantsmhits_outg_ploidy1_MASK.txt -t 1000 -s 1684 -v 2.0 -n chr10 2> valgrind27.txt
#../bin/ms 42 1000 -t 1000 -I 2 40 2 -ej 2.0 2 1 -p 9 > ./100Kchr10_simulation1000.ms.txt
#valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop  -f ms -i ./100Kchr10_simulation1000.ms.txt -o 1 -N 2 40 2 -G 1 -T ./mstatspop_100chr10.ms.13.txt -l 100000 -G 1 -u 1 -m ./100Kchr10_fa2ms_04b.ms.txt_npops2_nsam42_nonsynonymous_max_ExcludeMissingVariantsmhits_outg_ploidy1_MASK.txt -t 1000 -s 1684 -v 2.0 -r 1000 -n chr10 2> valgrind29.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 0 -N 1 42   -T ./mstatspop_100chr10.tfa.01.txt -w 100000 -n chr10 2> valgrind30.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 1 -N 1 42   -T ./mstatspop_100chr10.tfa.01b.txt -w 100000 -n chr10 2> valgrind31.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 1 -N 1 42   -T ./mstatspop_100chr10.tfa.01c.txt -w 1000 -n chr10 2> valgrind32.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 0 -N 2 40 2 -T ./mstatspop_100chr10.tfa.02.txt -w 100000 -n chr10 2> valgrind33.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 0 -N 2 40 2 -T ./mstatspop_100chr10.tfa.03.txt -G 1 -w 100000 -n chr10 2> valgrind34.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 0 -N 2 40 2 -T ./mstatspop_100chr10.tfa.04.txt -G 1 -u 1 -w 100000 -n chr10 2> valgrind35.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 1 -N 2 40 2 -T ./mstatspop_100chr10.tfa.06.txt -G 1 -u 1 -w 10000 -n chr10 2> valgrind36.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 1 -N 2 40 2 -T ./mstatspop_100chr10.tfa.07.txt -G 1 -u 1 -w 10000 -z 20000 -n chr10 2> valgrind37.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 0 -N 2 40 2 -T ./mstatspop_100chr10.tfa.08.txt -G 1 -u 1 -W ./coord_100Kb.txt -n chr10 2> valgrind38.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 0 -N 2 40 2 -T ./mstatspop_100chr10.tfa.09.txt -G 1 -u 1 -w 10000 -E ./100Kchr10_fa2tfa_08.tfa.gz_npops2_nsam42_nonsynonymous_max_IncludeMissingVariantsmhits_outg_ploidy1_WEIGHTS.gz -n chr10 2> valgrind39.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 0 -N 2 40 2 -T ./mstatspop_100chr10.tfa.10.txt -G 1 -u 1 -w 1000 -E ./100Kchr10_fa2tfa_08.tfa.gz_npops2_nsam42_nonsynonymous_max_IncludeMissingVariantsmhits_outg_ploidy1_WEIGHTS.gz -Y 0 -n chr10 2> valgrind40.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 1 -N 2 40 2 -T ./mstatspop_100chr10.tfa.10b.txt -G 1 -u 1 -w 1000 -E ./100Kchr10_fa2tfa_08.tfa.gz_npops2_nsam42_nonsynonymous_max_IncludeMissingVariantsmhits_outg_ploidy1_WEIGHTS.gz -Y 0 -n chr10 2> valgrind41.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 1 -N 2 40 2 -T ./mstatspop_100chr10.tfa.10c.txt -G 1 -u 1 -w 1000 -z 500 -E ./100Kchr10_fa2tfa_08.tfa.gz_npops2_nsam42_nonsynonymous_max_IncludeMissingVariantsmhits_outg_ploidy1_WEIGHTS.gz -Y 0 -n chr10 2> valgrind42.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 1 -N 2 40 2 -T ./mstatspop_100chr10.tfa.10d.txt -G 1 -u 1 -w 1000 -z 2000 -E ./100Kchr10_fa2tfa_08.tfa.gz_npops2_nsam42_nonsynonymous_max_IncludeMissingVariantsmhits_outg_ploidy1_WEIGHTS.gz -Y 0 -n chr10 2> valgrind43.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 0 -N 2 40 2 -T ./mstatspop_100chr10.tfa.11.txt -G 1 -u 1 -w 100000 -E ./100Kchr10_fa2tfa_08.tfa.gz_npops2_nsam42_nonsynonymous_max_IncludeMissingVariantsmhits_outg_ploidy1_WEIGHTS.gz -Y 0 -n chr10 2> valgrind44.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 0 -N 3 20 20 2 -T ./mstatspop_100chr10.tfa.12.txt -G 1 -u 1 -O 42 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 40 41 -w 100000 -n chr10 2> valgrind45.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 0 -N 3 20 20 2 -T ./mstatspop_100chr10.tfa.13.txt -G 1 -u 1  -w 100000 -E ./100Kchr10_tfa2tfa_03c.tfa.gz_npops3_nsam42_nonsynonymous_max_IncludeMissingVariantsmhits_outg_ploidy1_WEIGHTS.gz -n chr10 2> valgrind46.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 0 -N 3 20 20 2 -T ./mstatspop_100chr10.tfa.14.txt -G 1 -u 1  -w 100000 -O 42 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 40 41  -E ./100Kchr10_tfa2tfa_03c.tfa.gz_npops3_nsam42_nonsynonymous_max_IncludeMissingVariantsmhits_outg_ploidy1_WEIGHTS.gz -n chr10 2> valgrind47.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 0 -N 3 20 20 2 -T ./mstatspop_100chr10.tfa.14b.txt -G 1 -u 1  -w 100000 -O 42 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 40 41  -E ./100Kchr10_tfa2tfa_03c.tfa.gz_npops3_nsam42_nonsynonymous_max_IncludeMissingVariantsmhits_outg_ploidy1_WEIGHTS.gz -Y 0 -n chr10 2> valgrind48.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 1 -N 2 40 2 -T ./mstatspop_100chr10.tfa.15.txt -G 1 -u 1 -w 10000 -z 20000 -t 1000 -s 1684 -n chr10 2> valgrind49.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 1 -N 2 40 2 -T ./mstatspop_100chr10.tfa.16.txt -G 1 -u 1 -w 100 -z 100 -t 1000 -s 1684 -n chr10 2> valgrind50.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 1 -N 3 20 20 2 -T ./mstatspop_100chr10.tfa.17.txt -G 1 -u 1 -w 100 -z 100 -t 1000 -s 1684 -n chr10 2> valgrind51.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 1 -N 3 10 10 2 -T ./mstatspop_100chr10.tfa.18.txt -G 1 -u 1 -w 100 -z 100 -n chr10 2> valgrind52.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 1 -N 3 10 10 2 -T ./mstatspop_100chr10.tfa.19.txt -G 1 -u 1 -w 100 -z 100 -O 22 20 21 22 23 24 25 26 27 28 29 0 1 2 3 4 5 6 7 8 9 40 41 -n chr10 2> valgrind53.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kallchr.tfa.gz -o 0 -N 1 42   -T ./mstatspop_100allchr.tfa.01.txt   -w 100000 -n chr10,chr12,chr14 2> valgrind54.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kallchr.tfa.gz -o 1 -N 1 42   -T ./mstatspop_100allchr.tfa.01b.txt   -w 100000 -n chr10,chr12,chr14 2> valgrind55.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kallchr.tfa.gz -o 1 -N 1 42   -T ./mstatspop_100allchr.tfa.01c.txt -w 1000 -n chr10,chr12,chr14 2> valgrind56.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kallchr.tfa.gz -o 0 -N 2 40 2 -T ./mstatspop_100allchr.tfa.02.txt   -w 100000 -n chr10,chr12,chr14 2> valgrind57.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kallchr.tfa.gz -o 0 -N 2 40 2 -G 1 -T ./mstatspop_100allchr.tfa.03.txt   -w 100000 -n chr10,chr12,chr14 2> valgrind58.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kallchr.tfa.gz -o 0 -N 2 40 2 -G 1 -T ./mstatspop_100allchr.tfa.04.txt  -u 1 -w 100000 -n chr10,chr12,chr14 2> valgrind59.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kallchr.tfa.gz -o 0 -N 2 40 2 -G 1 -T ./mstatspop_100allchr.tfa.05.txt  -u 1 -w 100000 -n chr10,chr12 2> valgrind60.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kallchr.tfa.gz -o 1 -N 2 40 2 -G 1 -T ./mstatspop_100allchr.tfa.06.txt  -u 1 -w 10000 -n chr10,chr12,chr14 2> valgrind61.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kallchr.tfa.gz -o 1 -N 2 40 2 -G 1 -T ./mstatspop_100allchr.tfa.07.txt  -u 1 -z 20000 -w 10000 -n chr10,chr12,chr14 2> valgrind62.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kallchr.tfa.gz -o 1 -N 2 40 2 -G 1 -T ./mstatspop_100allchr.tfa.08c1.txt  -u 1 -W ./coord_100Kb_allchr.txt -n chr10,chr12,chr14 2> valgrind63.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kallchr.tfa.gz -o 0 -N 2 40 2 -T ./mstatspop_100allchr.tfa.09.txt -u 1 -w 10000 -E ./100Kallchr07.tfa.gz_npops2_nsam42_nonsynonymous_max_IncludeMissingVariantsmhits_outg_ploidy1_WEIGHTS.gz -n chr10,chr12,chr14 2> valgrind64.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kallchr.tfa.gz -o 0 -N 2 40 2 -T ./mstatspop_100allchr.tfa.10.txt -G 1 -u 1 -w 10000 -E ./100Kallchr07.tfa.gz_npops2_nsam42_nonsynonymous_max_IncludeMissingVariantsmhits_outg_ploidy1_WEIGHTS.gz -n chr10,chr12,chr14 2> valgrind65.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kallchr.tfa.gz -o 0 -N 2 40 2 -T ./mstatspop_100allchr.tfa.11.txt -G 1 -u 1 -w 100 -E ./100Kallchr07.tfa.gz_npops2_nsam42_nonsynonymous_max_IncludeMissingVariantsmhits_outg_ploidy1_WEIGHTS.gz -Y 0 -n chr10,chr12,chr14 2> valgrind66.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kallchr.tfa.gz -o 1 -N 3 10 10 2 -T ./mstatspop_100allchr.tfa.12.txt -G 1 -u 1 -w 100 -z 100 -O 22 20 21 22 23 24 25 26 27 28 29 0 1 2 3 4 5 6 7 8 9 40 41 -n chr10,chr12,chr14 2> valgrind67.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f fasta -i ./MC1R_PigsOutg_aligned.fas -o 0 -p 1 -u 0 -t 1000 -s 123456 -G 1 -N 3 48 46 1 -A ./MC1R_H1frq.txt -g ./MC1R.gff nonsynonymous Nuclear_Universal -T ./MC1R_PigsOutg_NSyn_Opttest.txt -n MC1R-1 2> valgrind68.txt
valgrind --leak-check=full --track-origins=yes -v ../bin/mstatspop -f tfa -i ./100Kchr10.tfa.gz -o 0 -N 1 2   -T ./mstatspop_100chr10.tfa.01.txt -w 100000 -n chr10 2> valgrind69.txt
